import { resolve } from 'path';
import { ethers, constants } from 'ethers';
import { blobToKzgCommitment, loadTrustedSetup, computeBlobKzgProof } from 'c-kzg';
import { Common } from '@ethereumjs/common';
import { BlobEIP4844Transaction } from '@ethereumjs/tx';
import defaultAxios from 'axios';
import { keccak256 } from 'ethereum-cryptography/keccak';
import { RLP } from '@ethereumjs/rlp';
import { ecsign } from '@ethereumjs/util';

var Network;
(function (Network) {
  Network["DencunDevnet12"] = "dencun-devnet-12";
  Network["EthDADevnet"] = "ethda-devnet";
})(Network || (Network = {}));

function _regeneratorRuntime() {
  _regeneratorRuntime = function () {
    return e;
  };
  var t,
    e = {},
    r = Object.prototype,
    n = r.hasOwnProperty,
    o = Object.defineProperty || function (t, e, r) {
      t[e] = r.value;
    },
    i = "function" == typeof Symbol ? Symbol : {},
    a = i.iterator || "@@iterator",
    c = i.asyncIterator || "@@asyncIterator",
    u = i.toStringTag || "@@toStringTag";
  function define(t, e, r) {
    return Object.defineProperty(t, e, {
      value: r,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), t[e];
  }
  try {
    define({}, "");
  } catch (t) {
    define = function (t, e, r) {
      return t[e] = r;
    };
  }
  function wrap(t, e, r, n) {
    var i = e && e.prototype instanceof Generator ? e : Generator,
      a = Object.create(i.prototype),
      c = new Context(n || []);
    return o(a, "_invoke", {
      value: makeInvokeMethod(t, r, c)
    }), a;
  }
  function tryCatch(t, e, r) {
    try {
      return {
        type: "normal",
        arg: t.call(e, r)
      };
    } catch (t) {
      return {
        type: "throw",
        arg: t
      };
    }
  }
  e.wrap = wrap;
  var h = "suspendedStart",
    l = "suspendedYield",
    f = "executing",
    s = "completed",
    y = {};
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}
  var p = {};
  define(p, a, function () {
    return this;
  });
  var d = Object.getPrototypeOf,
    v = d && d(d(values([])));
  v && v !== r && n.call(v, a) && (p = v);
  var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p);
  function defineIteratorMethods(t) {
    ["next", "throw", "return"].forEach(function (e) {
      define(t, e, function (t) {
        return this._invoke(e, t);
      });
    });
  }
  function AsyncIterator(t, e) {
    function invoke(r, o, i, a) {
      var c = tryCatch(t[r], t, o);
      if ("throw" !== c.type) {
        var u = c.arg,
          h = u.value;
        return h && "object" == typeof h && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) {
          invoke("next", t, i, a);
        }, function (t) {
          invoke("throw", t, i, a);
        }) : e.resolve(h).then(function (t) {
          u.value = t, i(u);
        }, function (t) {
          return invoke("throw", t, i, a);
        });
      }
      a(c.arg);
    }
    var r;
    o(this, "_invoke", {
      value: function (t, n) {
        function callInvokeWithMethodAndArg() {
          return new e(function (e, r) {
            invoke(t, n, e, r);
          });
        }
        return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }
    });
  }
  function makeInvokeMethod(e, r, n) {
    var o = h;
    return function (i, a) {
      if (o === f) throw new Error("Generator is already running");
      if (o === s) {
        if ("throw" === i) throw a;
        return {
          value: t,
          done: !0
        };
      }
      for (n.method = i, n.arg = a;;) {
        var c = n.delegate;
        if (c) {
          var u = maybeInvokeDelegate(c, n);
          if (u) {
            if (u === y) continue;
            return u;
          }
        }
        if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) {
          if (o === h) throw o = s, n.arg;
          n.dispatchException(n.arg);
        } else "return" === n.method && n.abrupt("return", n.arg);
        o = f;
        var p = tryCatch(e, r, n);
        if ("normal" === p.type) {
          if (o = n.done ? s : l, p.arg === y) continue;
          return {
            value: p.arg,
            done: n.done
          };
        }
        "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg);
      }
    };
  }
  function maybeInvokeDelegate(e, r) {
    var n = r.method,
      o = e.iterator[n];
    if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y;
    var i = tryCatch(o, e.iterator, r.arg);
    if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y;
    var a = i.arg;
    return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y);
  }
  function pushTryEntry(t) {
    var e = {
      tryLoc: t[0]
    };
    1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e);
  }
  function resetTryEntry(t) {
    var e = t.completion || {};
    e.type = "normal", delete e.arg, t.completion = e;
  }
  function Context(t) {
    this.tryEntries = [{
      tryLoc: "root"
    }], t.forEach(pushTryEntry, this), this.reset(!0);
  }
  function values(e) {
    if (e || "" === e) {
      var r = e[a];
      if (r) return r.call(e);
      if ("function" == typeof e.next) return e;
      if (!isNaN(e.length)) {
        var o = -1,
          i = function next() {
            for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next;
            return next.value = t, next.done = !0, next;
          };
        return i.next = i;
      }
    }
    throw new TypeError(typeof e + " is not iterable");
  }
  return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", {
    value: GeneratorFunctionPrototype,
    configurable: !0
  }), o(GeneratorFunctionPrototype, "constructor", {
    value: GeneratorFunction,
    configurable: !0
  }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) {
    var e = "function" == typeof t && t.constructor;
    return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name));
  }, e.mark = function (t) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t;
  }, e.awrap = function (t) {
    return {
      __await: t
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () {
    return this;
  }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) {
    void 0 === i && (i = Promise);
    var a = new AsyncIterator(wrap(t, r, n, o), i);
    return e.isGeneratorFunction(r) ? a : a.next().then(function (t) {
      return t.done ? t.value : a.next();
    });
  }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () {
    return this;
  }), define(g, "toString", function () {
    return "[object Generator]";
  }), e.keys = function (t) {
    var e = Object(t),
      r = [];
    for (var n in e) r.push(n);
    return r.reverse(), function next() {
      for (; r.length;) {
        var t = r.pop();
        if (t in e) return next.value = t, next.done = !1, next;
      }
      return next.done = !0, next;
    };
  }, e.values = values, Context.prototype = {
    constructor: Context,
    reset: function (e) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t);
    },
    stop: function () {
      this.done = !0;
      var t = this.tryEntries[0].completion;
      if ("throw" === t.type) throw t.arg;
      return this.rval;
    },
    dispatchException: function (e) {
      if (this.done) throw e;
      var r = this;
      function handle(n, o) {
        return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o;
      }
      for (var o = this.tryEntries.length - 1; o >= 0; --o) {
        var i = this.tryEntries[o],
          a = i.completion;
        if ("root" === i.tryLoc) return handle("end");
        if (i.tryLoc <= this.prev) {
          var c = n.call(i, "catchLoc"),
            u = n.call(i, "finallyLoc");
          if (c && u) {
            if (this.prev < i.catchLoc) return handle(i.catchLoc, !0);
            if (this.prev < i.finallyLoc) return handle(i.finallyLoc);
          } else if (c) {
            if (this.prev < i.catchLoc) return handle(i.catchLoc, !0);
          } else {
            if (!u) throw new Error("try statement without catch or finally");
            if (this.prev < i.finallyLoc) return handle(i.finallyLoc);
          }
        }
      }
    },
    abrupt: function (t, e) {
      for (var r = this.tryEntries.length - 1; r >= 0; --r) {
        var o = this.tryEntries[r];
        if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) {
          var i = o;
          break;
        }
      }
      i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null);
      var a = i ? i.completion : {};
      return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a);
    },
    complete: function (t, e) {
      if ("throw" === t.type) throw t.arg;
      return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y;
    },
    finish: function (t) {
      for (var e = this.tryEntries.length - 1; e >= 0; --e) {
        var r = this.tryEntries[e];
        if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y;
      }
    },
    catch: function (t) {
      for (var e = this.tryEntries.length - 1; e >= 0; --e) {
        var r = this.tryEntries[e];
        if (r.tryLoc === t) {
          var n = r.completion;
          if ("throw" === n.type) {
            var o = n.arg;
            resetTryEntry(r);
          }
          return o;
        }
      }
      throw new Error("illegal catch attempt");
    },
    delegateYield: function (e, r, n) {
      return this.delegate = {
        iterator: values(e),
        resultName: r,
        nextLoc: n
      }, "next" === this.method && (this.arg = t), y;
    }
  }, e;
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }
  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}
function _asyncToGenerator(fn) {
  return function () {
    var self = this,
      args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);
      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }
      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }
      _next(undefined);
    });
  };
}

function delay(_x) {
  return _delay.apply(this, arguments);
}
function _delay() {
  _delay = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(ms) {
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          return _context.abrupt("return", new Promise(function (res) {
            return setTimeout(res, ms);
          }));
        case 1:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return _delay.apply(this, arguments);
}

/* eslint-disable @typescript-eslint/no-explicit-any */
function debug(message) {
  if (process.env.NODE_ENV !== 'production') {
    var _console;
    for (var _len = arguments.length, optionalParams = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      optionalParams[_key - 1] = arguments[_key];
    }
    (_console = console).log.apply(_console, [message].concat(optionalParams));
  }
}

var NULL_ADDRESS = '0x0000000000000000000000000000000000000000';
var ZERO_BYTES32 = '0x0000000000000000000000000000000000000000000000000000000000000000';
var BlobTxBytesPerFieldElement = 32; // Size in bytes of a field element
var BlobTxFieldElementsPerBlob = 4096;
var BLOB_SIZE = BlobTxBytesPerFieldElement * BlobTxFieldElementsPerBlob;

function _getBytes(value, copy) {
  if (value instanceof Uint8Array) {
    if (copy) {
      return new Uint8Array(value);
    }
    return value;
  }
  if (typeof value === 'string' && value.match(/^0x([0-9a-f][0-9a-f])*$/i)) {
    var result = new Uint8Array((value.length - 2) / 2);
    var offset = 2;
    for (var i = 0; i < result.length; i++) {
      result[i] = parseInt(value.substring(offset, offset + 2), 16);
      offset += 2;
    }
    // console.log(result, result.length);
    return result;
  }
  return undefined;
}
function getBytes(value) {
  return _getBytes(value, false);
}
function computeVersionedHash(commitment, blobCommitmentVersion) {
  var computedVersionedHash = new Uint8Array(32);
  computedVersionedHash.set([blobCommitmentVersion], 0);
  var hash = getBytes(ethers.utils.sha256(commitment));
  computedVersionedHash.set(hash.subarray(1), 1);
  return computedVersionedHash;
}
function commitmentsToVersionedHashes(commitment) {
  return computeVersionedHash(commitment, 0x01);
}
function EncodeBlobs(data) {
  var len = data.length;
  if (len === 0) {
    throw Error('invalid blob data');
  }
  var blobIndex = 0;
  var fieldIndex = -1;
  var blobs = [new Uint8Array(BLOB_SIZE).fill(0)];
  for (var i = 0; i < len; i += 31) {
    fieldIndex++;
    if (fieldIndex === BlobTxFieldElementsPerBlob) {
      blobs.push(new Uint8Array(BLOB_SIZE).fill(0));
      blobIndex++;
      fieldIndex = 0;
    }
    var max = i + 31;
    if (max > len) {
      max = len;
    }
    blobs[blobIndex].set(data.subarray(i, max), fieldIndex * 32 + 1);
  }
  return blobs;
}
function DecodeBlob(blob) {
  if (!blob) {
    throw Error('invalid blob data');
  }
  blob = getBytes(blob);
  if (blob.length < BLOB_SIZE) {
    var newBlob = new Uint8Array(BLOB_SIZE).fill(0);
    newBlob.set(blob);
    blob = newBlob;
  }
  var data = [];
  var j = 0;
  for (var _i = 0; _i < BlobTxFieldElementsPerBlob; _i++) {
    var chunk = blob.subarray(j + 1, j + 32);
    data = [].concat(data, chunk);
    j += 32;
  }
  var i = data.length - 1;
  for (; i >= 0; i--) {
    if (data[i] !== 0x00) {
      break;
    }
  }
  var newData = data.slice(0, i + 1);
  return newData;
}
function DecodeBlobs(blobs) {
  if (!blobs) {
    throw Error('invalid blobs');
  }
  blobs = getBytes(blobs);
  var len = blobs.length;
  if (len === 0) {
    throw Error('invalid blobs');
  }
  var buf = [];
  for (var i = 0; i < len; i += BLOB_SIZE) {
    var max = i + BLOB_SIZE;
    if (max > len) {
      max = len;
    }
    var blob = blobs.subarray(i, max);
    var blobBuf = DecodeBlob(blob);
    buf = [].concat(buf, blobBuf);
  }
  return Buffer.from(buf);
}
function parseBigintValue(value) {
  if (value) {
    if (typeof value == 'bigint') {
      return '0x' + value.toString(16);
    }
    if (typeof value == 'object') {
      var _hex = value._hex;
      var c = BigInt(_hex);
      return '0x' + c.toString(16);
    }
  }
  return value;
}

var axios = /*#__PURE__*/defaultAxios.create({
  timeout: 30000
});
var BlobTransaction = /*#__PURE__*/function () {
  function BlobTransaction(jsonRpc, privateKey) {
    this._jsonRpc = jsonRpc;
    this._provider = new ethers.providers.JsonRpcProvider(jsonRpc);
    this._privateKey = privateKey;
    this._wallet = new ethers.Wallet(privateKey, this._provider);
    var SETUP_FILE_PATH = resolve(__dirname, 'lib', 'trusted_setup.txt');
    console.log(SETUP_FILE_PATH);
    loadTrustedSetup(SETUP_FILE_PATH);
  }
  var _proto = BlobTransaction.prototype;
  _proto.sendRpcCall = /*#__PURE__*/function () {
    var _sendRpcCall = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(method, parameters) {
      var response, returnedValue;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return axios({
              method: 'POST',
              url: this._jsonRpc,
              data: {
                jsonrpc: '2.0',
                method: method,
                params: parameters,
                id: 67
              }
            });
          case 3:
            response = _context.sent;
            _context.next = 10;
            break;
          case 6:
            _context.prev = 6;
            _context.t0 = _context["catch"](0);
            console.log('send error', _context.t0);
            return _context.abrupt("return", null);
          case 10:
            console.log('send response', response.data);
            returnedValue = response.data.result;
            if (!(returnedValue === '0x')) {
              _context.next = 14;
              break;
            }
            return _context.abrupt("return", null);
          case 14:
            if (!response.data.error) {
              _context.next = 16;
              break;
            }
            throw new Error(response.data.error);
          case 16:
            return _context.abrupt("return", returnedValue);
          case 17:
          case "end":
            return _context.stop();
        }
      }, _callee, this, [[0, 6]]);
    }));
    function sendRpcCall(_x, _x2) {
      return _sendRpcCall.apply(this, arguments);
    }
    return sendRpcCall;
  }();
  _proto.sendRawTransaction = /*#__PURE__*/function () {
    var _sendRawTransaction = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(param) {
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return this.sendRpcCall('eth_sendRawTransaction', [param]);
          case 2:
            return _context2.abrupt("return", _context2.sent);
          case 3:
          case "end":
            return _context2.stop();
        }
      }, _callee2, this);
    }));
    function sendRawTransaction(_x3) {
      return _sendRawTransaction.apply(this, arguments);
    }
    return sendRawTransaction;
  }();
  _proto.getChainId = /*#__PURE__*/function () {
    var _getChainId = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3() {
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) switch (_context3.prev = _context3.next) {
          case 0:
            if (this._chainId) {
              _context3.next = 4;
              break;
            }
            _context3.next = 3;
            return this.sendRpcCall('eth_chainId', []);
          case 3:
            this._chainId = _context3.sent;
          case 4:
            return _context3.abrupt("return", this._chainId);
          case 5:
          case "end":
            return _context3.stop();
        }
      }, _callee3, this);
    }));
    function getChainId() {
      return _getChainId.apply(this, arguments);
    }
    return getChainId;
  }();
  _proto.getNonce = /*#__PURE__*/function () {
    var _getNonce = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4() {
      return _regeneratorRuntime().wrap(function _callee4$(_context4) {
        while (1) switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return this._wallet.getTransactionCount('pending');
          case 2:
            return _context4.abrupt("return", _context4.sent);
          case 3:
          case "end":
            return _context4.stop();
        }
      }, _callee4, this);
    }));
    function getNonce() {
      return _getNonce.apply(this, arguments);
    }
    return getNonce;
  }();
  _proto.getFee = /*#__PURE__*/function () {
    var _getFee = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5() {
      return _regeneratorRuntime().wrap(function _callee5$(_context5) {
        while (1) switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return this._provider.getFeeData();
          case 2:
            return _context5.abrupt("return", _context5.sent);
          case 3:
          case "end":
            return _context5.stop();
        }
      }, _callee5, this);
    }));
    function getFee() {
      return _getFee.apply(this, arguments);
    }
    return getFee;
  }();
  _proto.suggestGasPrice = /*#__PURE__*/function () {
    var _suggestGasPrice = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee6() {
      return _regeneratorRuntime().wrap(function _callee6$(_context6) {
        while (1) switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return this.sendRpcCall('eth_gasPrice', []);
          case 2:
            return _context6.abrupt("return", _context6.sent);
          case 3:
          case "end":
            return _context6.stop();
        }
      }, _callee6, this);
    }));
    function suggestGasPrice() {
      return _suggestGasPrice.apply(this, arguments);
    }
    return suggestGasPrice;
  }();
  _proto.estimateGas = /*#__PURE__*/function () {
    var _estimateGas = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee7(params) {
      return _regeneratorRuntime().wrap(function _callee7$(_context7) {
        while (1) switch (_context7.prev = _context7.next) {
          case 0:
            _context7.next = 2;
            return this.sendRpcCall('eth_estimateGas', [params]);
          case 2:
            return _context7.abrupt("return", _context7.sent);
          case 3:
          case "end":
            return _context7.stop();
        }
      }, _callee7, this);
    }));
    function estimateGas(_x4) {
      return _estimateGas.apply(this, arguments);
    }
    return estimateGas;
  }();
  _proto.sanityCheck = /*#__PURE__*/function () {
    var _sanityCheck = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee8(tx) {
      var _to, _data, _maxPriorityFeePerGas;
      var chain, chainId, nonce, to, value, data, maxPriorityFeePerGas, maxFeePerGas, gasLimit, maxFeePerBlobGas;
      return _regeneratorRuntime().wrap(function _callee8$(_context8) {
        while (1) switch (_context8.prev = _context8.next) {
          case 0:
            _context8.next = 2;
            return this.getChainId();
          case 2:
            chain = _context8.sent;
            chainId = tx.chainId, nonce = tx.nonce, to = tx.to, value = tx.value, data = tx.data, maxPriorityFeePerGas = tx.maxPriorityFeePerGas, maxFeePerGas = tx.maxFeePerGas, gasLimit = tx.gasLimit, maxFeePerBlobGas = tx.maxFeePerBlobGas;
            if (chainId) {
              _context8.next = 8;
              break;
            }
            chainId = parseInt(chain, 16);
            _context8.next = 12;
            break;
          case 8:
            chainId = parseBigintValue(chainId);
            if (ethers.utils.isHexString(chainId)) {
              chainId = parseInt(chainId, 16);
            }
            if (!(chainId !== parseInt(chain, 16))) {
              _context8.next = 12;
              break;
            }
            throw Error('invalid network id');
          case 12:
            if (nonce) {
              _context8.next = 16;
              break;
            }
            _context8.next = 15;
            return this.getNonce();
          case 15:
            nonce = _context8.sent;
          case 16:
            value = !value ? '0x0' : parseBigintValue(value);
            // if (!maxFeePerGas) {
            //   const params = { from: this._wallet.address, to, data, value };
            //   // gasLimit = await this.estimateGas(params);
            //   maxFeePerGas = await this.suggestGasPrice();
            //   if (!maxFeePerGas) {
            //     throw Error('estimateGas: execution reverted');
            //   }
            // } else {
            //   maxFeePerGas = parseBigintValue(maxFeePerGas);
            // }
            maxFeePerGas = 1000000000n;
            // TODO
            maxFeePerBlobGas = !maxFeePerBlobGas ? 2000000000000 : parseBigintValue(maxFeePerBlobGas);
            to = (_to = to) != null ? _to : constants.AddressZero;
            gasLimit = 21000;
            data = (_data = data) != null ? _data : '0x';
            maxPriorityFeePerGas = (_maxPriorityFeePerGas = maxPriorityFeePerGas) != null ? _maxPriorityFeePerGas : 0;
            return _context8.abrupt("return", {
              chainId: chainId,
              nonce: nonce,
              to: to,
              value: value,
              data: data,
              maxPriorityFeePerGas: maxPriorityFeePerGas,
              maxFeePerGas: maxFeePerGas,
              gasLimit: gasLimit,
              maxFeePerBlobGas: maxFeePerBlobGas
            });
          case 24:
          case "end":
            return _context8.stop();
        }
      }, _callee8, this);
    }));
    function sanityCheck(_x5) {
      return _sanityCheck.apply(this, arguments);
    }
    return sanityCheck;
  }();
  _proto.sendTx = /*#__PURE__*/function () {
    var _sendTx = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee9(blobs, tx) {
      var _yield$this$sanityChe, chainId, nonce, to, value, data, maxFeePerGas, gasLimit, maxFeePerBlobGas, commitments, proofs, versionedHashes, i, common, message, signHash, pk, _ecsign, v, r, s, blobTx, rawData, hex;
      return _regeneratorRuntime().wrap(function _callee9$(_context9) {
        while (1) switch (_context9.prev = _context9.next) {
          case 0:
            _context9.next = 2;
            return this.sanityCheck(tx);
          case 2:
            _yield$this$sanityChe = _context9.sent;
            chainId = _yield$this$sanityChe.chainId;
            nonce = _yield$this$sanityChe.nonce;
            to = _yield$this$sanityChe.to;
            value = _yield$this$sanityChe.value;
            data = _yield$this$sanityChe.data;
            maxFeePerGas = _yield$this$sanityChe.maxFeePerGas;
            gasLimit = _yield$this$sanityChe.gasLimit;
            maxFeePerBlobGas = _yield$this$sanityChe.maxFeePerBlobGas;
            // blobs
            commitments = [];
            proofs = [];
            versionedHashes = [];
            for (i = 0; i < blobs.length; i++) {
              commitments.push(blobToKzgCommitment(blobs[i]));
              proofs.push(computeBlobKzgProof(blobs[i], commitments[i]));
              versionedHashes.push(commitmentsToVersionedHashes(commitments[i]));
            }
            common = Common.custom({
              name: 'ethda',
              networkId: chainId,
              chainId: chainId
            }, {
              eips: [1559, 3860, 4844]
            });
            console.log(chainId);
            message = [nonce, maxFeePerGas, gasLimit, to, value, data, 1001n, 0, 0];
            signHash = keccak256(RLP.encode(message));
            pk = getBytes('0x' + this._privateKey);
            _ecsign = ecsign(signHash, pk), v = _ecsign.v, r = _ecsign.r, s = _ecsign.s;
            v = 2n * 1001n + 8n + v;
            console.log(message, nonce, v, Buffer.from(r).toString('hex'), Buffer.from(s).toString('hex'));
            blobTx = new BlobEIP4844Transaction({
              chainId: chainId,
              nonce: nonce,
              to: to,
              value: value,
              data: data,
              maxPriorityFeePerGas: maxFeePerGas,
              maxFeePerGas: maxFeePerGas,
              gasLimit: gasLimit,
              maxFeePerBlobGas: maxFeePerBlobGas,
              blobVersionedHashes: versionedHashes,
              blobs: blobs,
              kzgCommitments: commitments,
              kzgProofs: proofs,
              v: v - 2n * 1001n - 35n,
              r: r,
              s: s
            }, {
              common: common
            });
            console.log(blobTx);
            rawData = blobTx.serializeNetworkWrapper();
            hex = Buffer.from(rawData).toString('hex');
            _context9.next = 30;
            return this.sendRawTransaction('0x' + hex);
          case 30:
            return _context9.abrupt("return", _context9.sent);
          case 31:
          case "end":
            return _context9.stop();
        }
      }, _callee9, this);
    }));
    function sendTx(_x6, _x7) {
      return _sendTx.apply(this, arguments);
    }
    return sendTx;
  }();
  _proto.isTransactionMined = /*#__PURE__*/function () {
    var _isTransactionMined = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee10(transactionHash) {
      var txReceipt;
      return _regeneratorRuntime().wrap(function _callee10$(_context10) {
        while (1) switch (_context10.prev = _context10.next) {
          case 0:
            _context10.next = 2;
            return this._provider.getTransactionReceipt(transactionHash);
          case 2:
            txReceipt = _context10.sent;
            if (!(txReceipt && txReceipt.blockNumber)) {
              _context10.next = 5;
              break;
            }
            return _context10.abrupt("return", txReceipt);
          case 5:
            return _context10.abrupt("return", null);
          case 6:
          case "end":
            return _context10.stop();
        }
      }, _callee10, this);
    }));
    function isTransactionMined(_x8) {
      return _isTransactionMined.apply(this, arguments);
    }
    return isTransactionMined;
  }();
  _proto.getTxReceipt = /*#__PURE__*/function () {
    var _getTxReceipt = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee11(transactionHash) {
      var txReceipt;
      return _regeneratorRuntime().wrap(function _callee11$(_context11) {
        while (1) switch (_context11.prev = _context11.next) {
          case 0:
            if (txReceipt) {
              _context11.next = 10;
              break;
            }
            _context11.next = 3;
            return this.isTransactionMined(transactionHash);
          case 3:
            txReceipt = _context11.sent;
            if (!txReceipt) {
              _context11.next = 6;
              break;
            }
            return _context11.abrupt("break", 10);
          case 6:
            _context11.next = 8;
            return delay(5000);
          case 8:
            _context11.next = 0;
            break;
          case 10:
            return _context11.abrupt("return", txReceipt);
          case 11:
          case "end":
            return _context11.stop();
        }
      }, _callee11, this);
    }));
    function getTxReceipt(_x9) {
      return _getTxReceipt.apply(this, arguments);
    }
    return getTxReceipt;
  }();
  _proto.getBlobHash = function getBlobHash(blob) {
    var commit = blobToKzgCommitment(blob);
    var localHash = commitmentsToVersionedHashes(commit);
    var hash = new Uint8Array(32);
    hash.set(localHash.subarray(0, 32 - 8));
    return ethers.utils.hexlify(hash);
  };
  return BlobTransaction;
}();

export { BLOB_SIZE, BlobTransaction, BlobTxBytesPerFieldElement, BlobTxFieldElementsPerBlob, DecodeBlob, DecodeBlobs, EncodeBlobs, NULL_ADDRESS, Network, ZERO_BYTES32, commitmentsToVersionedHashes, computeVersionedHash, debug, delay, getBytes, parseBigintValue };
//# sourceMappingURL=blobs.esm.js.map
